;; This "home-environment" file can be passed to 'guix home reconfigure'
;; to reproduce the content of your profile.  This is "symbolic": it only
;; specifies package names.  To reproduce the exact same profile, you also
;; need to capture the channels being used, as returned by "guix describe".
;; See the "Replicating Guix" section in the manual.

(use-modules (gnu home)
             (gnu packages)
             (gnu packages xdisorg)
             (gnu services)
             (guix gexp)
             (gnu home services shells)
             (gnu home services desktop)
             (gnu home services pm)
             (gnu home services sound))

(home-environment
  ;; Below is the list of packages that will show up in your
  ;; Home profile, under ~/.guix-home/profile.
  (packages (specifications->packages (list "htop"
                                            "emacs-pgtk"
                                            "binutils"
                                            "gcc-toolchain@11"
                                            "icecat-l10n:sl"
                                            "icecat"
                                            "crawl-tiles"
                                            "acpi"
                                            "zynaddsubfx"
                                            "gnome-tweaks"
                                            "gimp"
                                            "supercollider"
                                            "ardour"
                                            "slurp"
                                            "wireplumber"
                                            "pipewire"
                                            "qjackctl"
                                            "mplayer"
                                            "ffmpeg"
                                            "libcaca"
                                            "kigo"
                                            "lierolibre"
                                            "transmission:gui"
                                            "wine64"
                                            "wine"
                                            "audacity"
                                            "numix-gtk-theme"
                                            "nextcloud-client"
                                            "nyxt"
                                            "icedove-wayland"
                                            "ungoogled-chromium-wayland"
                                            "keepassxc"
                                            "libappindicator"
                                            "snixembed"
                                            "vlc"
                                            "qpwgraph"
                                            "pamixer"
                                            "element-desktop"
                                            "pavucontrol"
                                            "libreoffice"
                                            "mako"
                                            "alacritty"
                                            "redshift-wayland"
                                            "i3status"
                                            "rofi-wayland"
                                            "sway"
                                            "wev"
                                            "grim"
                                            "xjackfreak"
                                            "ncdu"
                                            "bind:utils"
                                            "python-i3ipc"
                                            "python"
                                            "screen"
                                            "bibata-cursor-theme"
                                            "ripgrep"
                                            "brightnessctl"
                                            "foot"
                                            "jack"
                                            "amb-plugins"
                                            "fil-plugins"
                                            "gnugo"
                                            "bsd-games"
                                            "file"
                                            "nmap"
                                            "font-fira-code"
                                            "font-awesome"
                                            "unzip"
                                            "zsh"
                                            "curl")))

  ;; Below is the list of Home services.  To search for available
  ;; services, run 'guix home search KEYWORD' in a terminal.
  (services
   (list (service home-zsh-service-type
                  (home-zsh-configuration
                   (zshrc (list (local-file
                                 "/home/g1smo/sredstva/dotfiles/.zshrc"
                                 "zshrc")))
                   (zprofile (list (local-file
                                    "/home/g1smo/sredstva/dotfiles/.profile"
                                    "profile")))))
         
         ;; Skrij misko po 4 sekundah ne-premikanja
         (service home-unclutter-service-type
                  (home-unclutter-configuration
                   (idle-timeout 2)))

         ;; Rdecenje zaslona @TODO se ne dela :(
         (service home-redshift-service-type
                  (home-redshift-configuration
                   (redshift redshift-wayland)
                   (adjustment-method 'wayland)
                   (location-provider 'manual)
                   (latitude 46.05108)
                   (longitude 14.50513)))


         ;; Pipewire zvok!
         ;; Dbus je odvisen paket
         (service home-dbus-service-type)
         (service home-pipewire-service-type)

         ;; Indikator nizke baterije
         (service home-batsignal-service-type)
         )))
